/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.j2ee.blueprints.ui;

/**
 * Base class for tab panels that appear on the main BluePrints panel.
 * This provides common functionality such as saving / restoring
 * the current scroll position.
 *
 * @author Mark Roth
 */
public abstract class BluePrintsTabPanel extends javax.swing.JPanel {

    /** Creates new form BluePrintsTabPanel */
    public BluePrintsTabPanel(BluePrintsPanel bluePrintsPanel) {
        this.bluePrintsPanel = bluePrintsPanel;
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        
        setLayout(new java.awt.BorderLayout());
        
    }//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

    /** The panel that contains this tab */
    protected BluePrintsPanel bluePrintsPanel;
    
    /**
     * Returns the current scroll position so that when the user navigates
     * to a new article we can keep track of where the user was in this tab.
     *
     * @return The current scroll position in this tab.
     */
    public abstract int getScrollPosition();
    
    /**
     * Sets the current scroll position so that when the user uses the
     * Back or Forward button we can return the user to where they
     * were reading before they left off.
     *
     * @param scrollPosition The scroll position in this tab.
     */
    public abstract void setScrollPosition(int scrollPosition);

    /**
     * Called when the tab needs to be updated because a new article has
     * been selected.
     */
    public abstract void updateTab();
}
