/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.php.project.wizards;

import javax.swing.DefaultComboBoxModel;
import org.openide.WizardDescriptor;

/**
 *
 * @author  ads
 */
class PhpVersionPanel extends javax.swing.JPanel {

    private static final long serialVersionUID = 2168064940970450732L;

    /** Creates new form PhpVersionPanel */
    PhpVersionPanel(PhpSourcesConfigurePanel panel) {
        myPanel = panel;

        initComponents();

        init();
    }

    void read(WizardDescriptor descriptor) {
        Object obj = descriptor.getProperty(NewPhpProjectWizardIterator.VERSION);
        Versions version = null;
        if (obj instanceof Versions) {
            version = (Versions) obj;
        }

        if (version == null) {
            String defaultVersion = getPanel().getDefaultPhpVersion();
            int intValue = Integer.parseInt(defaultVersion);
            version = Versions.valueOf(intValue);
        }
        if (version != null) {
            myVersion.setSelectedItem(version);
        }
    }

    boolean dataIsValid( WizardDescriptor wizardDescriptor) {
        return true;
    }

    void store(WizardDescriptor descriptor) {
        descriptor.putProperty(NewPhpProjectWizardIterator.VERSION, myVersion.getSelectedItem());
    }

    private void init() {
        myVersion.setModel(new DefaultComboBoxModel(Versions.values()));
    }

    private PhpSourcesConfigurePanel getPanel() {
        return myPanel;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        myVersion = new javax.swing.JComboBox();
        myLabel = new javax.swing.JLabel();

        org.openide.awt.Mnemonics.setLocalizedText(myLabel, org.openide.util.NbBundle.getMessage(PhpVersionPanel.class, "LBL_ChooseVersion")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(myLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(myVersion, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(78, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(myLabel)
                    .add(myVersion, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    enum Versions {

        FOUR(4), FIVE(5);

        Versions(int i) {
            myNumber = i;
        }

        public static Versions valueOf(int version) {
            switch (version) {
                case 4:
                    return FOUR;
                case 5:
                    return FIVE;
                default:
                    return null;
            }
        }

        public String toString() {
            return Integer.toString(myNumber);
        }

        private int myNumber;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel myLabel;
    private javax.swing.JComboBox myVersion;
    // End of variables declaration//GEN-END:variables
    private PhpSourcesConfigurePanel myPanel;
}
