/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.xslt.model;


/**
 * <pre>
 * &lt;xs:element name="number" substitutionGroup="xsl:instruction">
 *      &lt;xs:complexType>
 *          &lt;xs:complexContent mixed="true">
 *              &lt;xs:extension base="xsl:versioned-element-type">
 *                  &lt;xs:attribute name="value" type="xsl:expression"/>
 *                  &lt;xs:attribute name="select" type="xsl:expression"/>
 *                  &lt;xs:attribute name="level" type="xsl:level" default="single"/>
 *                  &lt;xs:attribute name="count" type="xsl:pattern"/>
 *                  &lt;xs:attribute name="from" type="xsl:pattern"/>
 *                  &lt;xs:attribute name="format" type="xsl:avt" default="1"/>
 *                  &lt;xs:attribute name="lang" type="xsl:avt"/>
 *                  &lt;xs:attribute name="letter-value" type="xsl:avt"/>
 *                  &lt;xs:attribute name="ordinal" type="xsl:avt"/>        
 *                  &lt;xs:attribute name="grouping-separator" type="xsl:avt"/>
 *                  &lt;xs:attribute name="grouping-size" type="xsl:avt"/>
 *              &lt;/xs:extension>
 *          &lt;/xs:complexContent>
 *      &lt;/xs:complexType>
 * &lt;/xs:element>
 * </pre>
 * @author ads
 *
 */
public interface Number extends ContentElement, SelectSpec, Instruction, LangSpec,
    FormatSpec 
{

    String VALUE                = "value";          // NOI18N
    
    String LEVEL                = "level";          // NOI18N
    
    String COUNT                = "count";          // NOI18N
    
    String FROM                 = "from";           // NOI18N
    
    String LETTER_VALUE         = "letter-value";   // NOI18N
        
    String ORDINAL              = "ordinal";        // NOI18N     
    
    String GROUPING_SIZE        = "grouping-size";  // NOI18N
    
    String GROUPING_SEPARATOR   = DecimalFormat.GROUPING_SEPARATOR;
}
