/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.modules.xslt.model.impl;

import java.util.List;

import org.netbeans.modules.xslt.model.CallTemplate;
import org.netbeans.modules.xslt.model.Template;
import org.netbeans.modules.xslt.model.WithParam;
import org.netbeans.modules.xslt.model.XslComponent;
import org.netbeans.modules.xslt.model.XslReference;
import org.netbeans.modules.xslt.model.XslVisitor;
import org.w3c.dom.Element;


/**
 * @author ads
 *
 */
class CallTemplateImpl extends XslComponentImpl implements CallTemplate {

    CallTemplateImpl( XslModelImpl model, Element element ) {
        super( model , element );
    }
    
    CallTemplateImpl( XslModelImpl model ){
        super( model , XslElements.CALL_TEMPLATE );
    }

    /* (non-Javadoc)
     * @see org.netbeans.modules.xslt.model.impl.XslComponentImpl#accept(org.netbeans.modules.xslt.model.XslVisitor)
     */
    @Override
    public void accept( XslVisitor visitor )
    {
        visitor.visit( this );
    }

    /* (non-Javadoc)
     * @see org.netbeans.modules.xslt.model.impl.XslComponentImpl#getComponentType()
     */
    @Override
    public Class<? extends XslComponent> getComponentType()
    {
        return CallTemplate.class;
    }

    /* (non-Javadoc)
     * @see org.netbeans.modules.xslt.model.WithParamContainer#addWithParam(org.netbeans.modules.xslt.model.WithParam, int)
     */
    public void addWithParam( WithParam withParam, int position ) {
        insertAtIndex( WITH_PARAM, withParam, position);
    }

    /* (non-Javadoc)
     * @see org.netbeans.modules.xslt.model.WithParamContainer#appendWithParam(org.netbeans.modules.xslt.model.WithParam)
     */
    public void appendWithParam( WithParam withParam ) {
        appendChild( WITH_PARAM, withParam);
    }

    /* (non-Javadoc)
     * @see org.netbeans.modules.xslt.model.WithParamContainer#getWithParams()
     */
    public List<WithParam> getWithParams() {
        return getChildren( WithParam.class );
    }

    /* (non-Javadoc)
     * @see org.netbeans.modules.xslt.model.WithParamContainer#removeWithParam(org.netbeans.modules.xslt.model.WithParam)
     */
    public void removeWithParam( WithParam withParam ) {
        removeChild( WITH_PARAM, withParam);
    }

    /* (non-Javadoc)
     * @see org.netbeans.modules.xslt.model.CallTemplate#getName()
     */
    public XslReference<Template> getName() {
        return resolveGlobalReference( Template.class, 
                XslAttributes.NAME_OF_CALL_TMPL );
    }

    /* (non-Javadoc)
     * @see org.netbeans.modules.xslt.model.CallTemplate#setName(org.netbeans.modules.xml.xam.Reference)
     */
    public void setName( XslReference<Template> name ) {
        setAttribute( XslAttributes.NAME_OF_CALL_TMPL, name );
    }

}
